{*****************************************************************************}
{*                                                                           *}
{*                                                *}
{*                                                                           *}
{*                            .                        *}
{*                  +    =                  *}
{*                                                                           *}
{*           : , 1980,  "".    226         *}
{*                                                                           *}
{*****************************************************************************}
{*                                                                           *}
{*               .  *}
{*              ,    *}
{*         (message).             *}
{*             CrossReference    *}
{*   .    ,      *}
{*      (Pascal only),            *}
{*    .                                                            *}
{*                                                                           *}
{*  :     (*$define ASM*)        *}
{*              Cross Reference   .             *}
{*                                                                           *}
{*****************************************************************************}

{$define NoListing}                   (*       *)
{ $define ASM}
program {$ifdef ASM} Acref {$else} cref {$endif} (output, message);
  const                                                           {$ifdef ASM }
        c1 = 16;                                            {    }
        c2 =  4;                                     {      }
                                                                        {$else}
        c1 =  8;                                            {    }
        c2 =  5;                                     {      }
                                                                       {$endif}
        c3 =  6;                                    {      }

  type alpha = packed array [0..c1-1] of char;

       WordRef = ^word;
       ItemRef = ^item;

       word = record
         left, right: WordRef;
         key:         alpha;
         first, last: ItemRef;
       end; { word }

       Item = record
         lno:  Cardinal;
         next: ItemRef;
       end; { Item }

  var root:   WordRef;
      ch,
      ch1:    char;
      k:      integer;                                      {    }
      n:      Cardinal;                                {     }
      Nitems: Cardinal;
                                                                  {$ifNdef ASM}
      lbra:   boolean;         {        '*' }
                                                                       {$endif}
      id:     alpha;
      f:      text;

  procedure Search(var w1: WordRef);
    var w: WordRef;
        x: ItemRef;
  begin
  w:= w1;
  if w = nil
    then begin new(w); new(x);
         with w^ do
           begin key:= id;
           left:= nil; right:= nil;
           first:= x;  last:= x;
           end; { with w^ }
         x^.lno:= n; x^.next:= nil; w1:= w;
         end
    else if id < w^.key
      then Search(w^.left)
    else if id > w^.key
      then Search(w^.right)
    else begin new(x);
         x^.lno:= n; x^.next:= nil;
         w^.last^.next:= x; w^.last:= x;
         end
  end; { Search }

  procedure PrintTree(w: WordRef);

    procedure PrintWord(w: WordRef);
    var l: integer;
        x: ItemRef;
    begin
    Inc(Nitems);
    write(message, Nitems: 5, #13);
    write(w^.key, ' ');
    x:= w^.first; l:= 0;
    repeat
      if l = c2
        then begin writeln; l:= 0;
             write(' ': c1 + 1);
             end;
      Inc(l); write(x^.lno: c3);
      x:= x^.next;
    until x = nil;
    writeln;
    end; { PrintWord }

  begin { PrintTree }
  if w <> nil
    then begin
         PrintTree(w^.left);
         PrintWord(w);
         PrintTree(w^.right);
         end
  end; { PrintTree }

  procedure OpenFile;
    var name: string;
  begin
  if ParamCount <> 1
    then begin write(message,                                      {$ifdef ASM}
                     'usage: cref <filename>');                         {$else}
                     'usage: acref <filename>');                       {$endif}
         halt
         end;
  {$I-}
  ParamStr(1, name); reset(f, name);
  if IOresult <> 0
    then begin write(message, '     ', name); halt end;
  {$I+}
  end; { OpenFile }

begin { CrossRef }                                                 {$ifdef ASM}
write(message, 'ASM ');                                                {$endif}
writeln(message, 'CrossReference, version 1.10.');
OpenFile;
root:= nil; n:= 0;
write(message, 0: 7, ' lines processed'#13);
while not eof(f) do
  begin Inc(n);
  write(message, n: 7, #13);                                {$ifNdef NoListing}
  write(n: 7, ' ');                                                    {$endif}
  {$ifNdef ASM} lbra:= false; {$endif}
  while not eoln(f) do
    begin read(f, ch); {$ifNdef NoListing} write(ch); {$endif}
    ch1:= UpCase(ch);
    if ch1 in ['A'..'Z', '_']
      then begin k:= 0;
           FillChar(id, SizeOf(id), ' ');
           repeat
             if k < c1
               then begin id[k]:= ch1; Inc(k); end;
             if eoln(f)
               then ch:= ' '
               else begin read(f, ch);                      {$ifNdef NoListing}
                    write(ch);                                         {$endif}
                    end;
             ch1:= UpCase(ch);
           until not (ch1 in ['A'..'Z', '_', '0'..'9']);
           Search(root);
           end;

    if (ch = '$') and not eoln(f)   {    $  ,  ... }
      then begin                  {     }
           repeat read(f, ch);                              {$ifNdef NoListing}
             write(ch);                                                {$endif}
           until not (UpCase(ch) in ['A'..'F', '_', '0'..'9']) or eoln(f)
           end
    else if ch = "'"
      then repeat read(f, ch);                              {$ifNdef NoListing}
             write(ch);                                                {$endif}
           until ch = "'"
      else if ch = '"'
        then repeat read(f, ch);                            {$ifNdef NoListing}
               write(ch);                                              {$endif}
             until ch = '"'
                                                                  {$ifdef ASM }
      else if ch = ';'
        then while not eoln(f) do
               begin read(f, ch); {$ifNdef NoListing} write(ch); {$endif} end;
                                                                        {$else}
      else if ch = '{'
        then repeat
               while eoln(f) do
                 begin {$ifNdef NoListing} writeln; {$endif}
                 write(message, n: 7, #13);
                 Inc(n); {$ifNdef NoListing} write(n: 7, ' '); {$endif}
                 readln(f);
                 end;
               read(f, ch); {$ifNdef NoListing} write(ch); {$endif}
             until ch = '}'
      else if (ch = '*') and lbra
        then repeat
               repeat
                 while eoln(f) do
                   begin {$ifNdef NoListing} writeln; {$endif}
                   write(message, n: 7, #13);
                   Inc(n); {$ifNdef NoListing} write(n: 7, ' ');  {$endif}
                   readln(f);
                   end;
                 read(f, ch); {$ifNdef NoListing} write(ch); {$endif}
               until ch = '*';
               while (not eoln(f)) and (ch = '*') do
                 begin read(f, ch);                         {$ifNdef NoListing}
                 write(ch);                                            {$endif}
                 end;
             until ch = ')';
    lbra:= ch = '(';
                                                                       {$endif}
    end; { while not eoln(f) }
  readln(f); {$ifNdef NoListing} writeln; {$endif}
  end; { while not eof(f) }
{$ifNdef NoListing} writeln; {$endif}
writeln(message, #24'Creating Cross Reference List');
write(message, 0: 5, ' items listed'#13);
writeln('Cross Reference List:');
Nitems:= 0;
PrintTree(root);
end. { CrossRef }
